signature lib_set_sig =
  sig
    pred empty/1 and insert/3 and memberof/2 and eqset/2.
  end.

structure lib_set/lib_set_sig =
  struct
    fun set/1.
    empty(set([])).
    insert(Item,set(Set),set(New)) :-
        member(Item,Set) -> New = Set ;
                            New = [Item|Set].
    memberof(Item,set(Set)) :-
        member(Item,Set).
    eqset(set(X),set(Y)) :-
        sort(X,X1),
        sort(Y,Y1),
        X1 = Y1.
  end.
