/************************************************************************
*									*
* The SB-Prolog System							*
* Copyright SUNY at Stony Brook, 1986; University of Arizona, 1987	*
*									*
************************************************************************/

/*-----------------------------------------------------------------
SB-Prolog is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY.  No author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  Refer to the SB-Prolog General Public
License for full details.

Everyone is granted permission to copy, modify and redistribute
SB-Prolog, but only under the conditions described in the
SB-Prolog General Public License.   A copy of this license is
supposed to have been given to you along with SB-Prolog so you
can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice
and this notice must be preserved on all copies. 
------------------------------------------------------------------ */
/*  This is the file of operators for read/1 and read/2.  It really
    belongs in the file $read.P, but is here so that the assembler won't
    optimize away the indirect linkages to it.  This allows op
    declarations to be handled correctly.  -- S. Debray, Dec 22, 1987.  */


/****************************************************************************
 *                                                                          *
 * This file has been changed by to include Modules Extensions              *
 * Changes by : Brian Paxton 1991/92                                        *
 * Last update : June 1992                                                  *
 *                                                                          *
 * Organisation : University of Edinburgh.                                  *
 * For : Departments of Computer Science and Artificial Intelligence        * 
 *       Fourth Year Project.                                               *
 *                                                                          *
 ****************************************************************************/

$read_curr_op(1200,xfx,(':-')).
$read_curr_op(1200,xfx,('-->')).
$read_curr_op(1200,fx,(':-')).
$read_curr_op(1198,xfx,('::-')).
$read_curr_op(1100,xfy,';').
$read_curr_op(1050,xfy,'->').
$read_curr_op(1000,xfy,',').
$read_curr_op(900,fy,not).
$read_curr_op(900,fy,'\+').
$read_curr_op(900,fy,spy).
$read_curr_op(900,fy,nospy).
$read_curr_op(1150,fy,(mode)).
/* $read_curr_op(700,xfx,'=').   for modules */
$read_curr_op(700,xfx,is).
$read_curr_op(700,xfx,'=..').
$read_curr_op(700,xfx,'?=').
$read_curr_op(700,xfx,'\=').
$read_curr_op(700,xfx,'==').
$read_curr_op(700,xfx,'\==').
$read_curr_op(700,xfx,'@<').
$read_curr_op(700,xfx,'@>').
$read_curr_op(700,xfx,'@=<').
$read_curr_op(700,xfx,'@>=').
$read_curr_op(700,xfx,'=:=').
$read_curr_op(700,xfx,'=\=').
$read_curr_op(700,xfx,'<').
$read_curr_op(700,xfx,'>').
$read_curr_op(700,xfx,'=<').
$read_curr_op(700,xfx,'>=').
$read_curr_op(661,xfy,'.').	/* !! */
$read_curr_op(500,yfx,'+').
$read_curr_op(500,yfx,'-').
$read_curr_op(500,yfx,'/\').
$read_curr_op(500,yfx,'\/').
$read_curr_op(500,fx,'+').
$read_curr_op(500,fx,'-').
$read_curr_op(500,fx,'\').
$read_curr_op(400,yfx,'*').
$read_curr_op(400,yfx,'/').
$read_curr_op(400,yfx,'//').
$read_curr_op(400,yfx,'<<').
$read_curr_op(400,yfx,'>>').
$read_curr_op(300,xfx,mod).
$read_curr_op(200,xfy,'^').

% The following have been added to handle module facilities.

$read_curr_op(700,xfy,'=').
$read_curr_op(750,xfx,sharing).
$read_curr_op(760,fx,inherit).
$read_curr_op(760,fx,pred).
$read_curr_op(760,fx,fun).
$read_curr_op(760,fx,functor).
$read_curr_op(760,fx,signature).
$read_curr_op(760,fx,structure).
$read_curr_op(690,fx,struct).
$read_curr_op(690,fx,sig).
$read_curr_op(730,xfy,and).
$read_curr_op(450,xfy,--->).
$read_curr_op(100,xfy,:).

% The operator = has been changed to allow input of terms like :
%     sharing a = b = c and d = e = f.